"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var _metadata_keys_1 = require("./_metadata-keys");
function Teardown(target, decoratedPropertyKey, descriptor) {
    var teardownFunctions = Reflect.getMetadata(_metadata_keys_1.TEARDOWN, target);
    if (!teardownFunctions) {
        teardownFunctions = [];
    }
    teardownFunctions.push({
        isAsync: false,
        propertyKey: decoratedPropertyKey
    });
    // mark as teardown test method
    Reflect.defineMetadata(_metadata_keys_1.TEARDOWN, teardownFunctions, target);
}
exports.Teardown = Teardown;
;
//# sourceMappingURL=teardown-decorator.js.map