"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var _metadata_keys_1 = require("./_metadata-keys");
function Timeout(timeoutInMs) {
    if (timeoutInMs <= 0) {
        throw new RangeError("Timeout period must be greater than 0.");
    }
    return function (target, propertyKey, descriptor) {
        Reflect.defineMetadata(_metadata_keys_1.TIMEOUT, timeoutInMs, target, propertyKey);
    };
}
exports.Timeout = Timeout;
//# sourceMappingURL=timeout-decorator.js.map