"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var test_outcome_1 = require("./test-outcome");
var test_results_1 = require("./test-results");
var TestFixtureResults = (function () {
    function TestFixtureResults(_testFixture) {
        this._testFixture = _testFixture;
        this._testResults = [];
    }
    Object.defineProperty(TestFixtureResults.prototype, "testResults", {
        get: function () {
            return this._testResults;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TestFixtureResults.prototype, "fixture", {
        get: function () {
            return this._testFixture;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TestFixtureResults.prototype, "outcome", {
        get: function () {
            var outcomes = this._testResults.map(function (testResult) { return testResult.outcome; });
            if (outcomes.indexOf(test_outcome_1.TestOutcome.Error) !== -1) {
                return test_outcome_1.TestOutcome.Error;
            }
            if (outcomes.indexOf(test_outcome_1.TestOutcome.Fail) !== -1) {
                return test_outcome_1.TestOutcome.Fail;
            }
            if (outcomes.indexOf(test_outcome_1.TestOutcome.Pass) !== -1) {
                return test_outcome_1.TestOutcome.Pass;
            }
            return test_outcome_1.TestOutcome.Skip;
        },
        enumerable: true,
        configurable: true
    });
    TestFixtureResults.prototype.addTestResult = function (test) {
        var testResults = new test_results_1.TestResults(test);
        this._testResults.push(testResults);
        return testResults;
    };
    return TestFixtureResults;
}());
exports.TestFixtureResults = TestFixtureResults;
//# sourceMappingURL=test-fixture-results.js.map