"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var test_fixture_results_1 = require("./test-fixture-results");
var test_outcome_1 = require("./test-outcome");
var TestSetResults = (function () {
    function TestSetResults() {
        this._testFixtureResults = [];
    }
    Object.defineProperty(TestSetResults.prototype, "testFixtureResults", {
        get: function () {
            return this._testFixtureResults;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TestSetResults.prototype, "outcome", {
        get: function () {
            var outcomes = this._testFixtureResults.map(function (testFixtureResult) { return testFixtureResult.outcome; });
            if (outcomes.indexOf(test_outcome_1.TestOutcome.Error) !== -1) {
                return test_outcome_1.TestOutcome.Error;
            }
            if (outcomes.indexOf(test_outcome_1.TestOutcome.Fail) !== -1) {
                return test_outcome_1.TestOutcome.Fail;
            }
            if (outcomes.indexOf(test_outcome_1.TestOutcome.Pass) !== -1) {
                return test_outcome_1.TestOutcome.Pass;
            }
            return test_outcome_1.TestOutcome.Skip;
        },
        enumerable: true,
        configurable: true
    });
    TestSetResults.prototype.addTestFixtureResult = function (testFixture) {
        var testFixtureResult = new test_fixture_results_1.TestFixtureResults(testFixture);
        this._testFixtureResults.push(testFixtureResult);
        return testFixtureResult;
    };
    return TestSetResults;
}());
exports.TestSetResults = TestSetResults;
//# sourceMappingURL=test-set-results.js.map