/// <reference types="node" />
import { Readable as ReadableStream } from "stream";
import { ITestFixture } from "./_interfaces";
import { TestCaseResult } from "./results";
export declare class TestOutputStream extends ReadableStream {
    _read(): void;
    end(): void;
    emitVersion(): void;
    emitPlan(testCount: number): void;
    emitFixture(fixture: ITestFixture): void;
    emitResult(testId: number, result: TestCaseResult): void;
    private _writeOut(message);
    private _emitPass(testId, test, testCaseArguments);
    private _emitSkip(testId, test, testCaseArguments);
    private _emitFail(testId, test, testCaseArguments, error);
    private _getTestDescription(test, testCaseArguments);
    private _getArgumentDescription(argument);
    private _writeMatchErrorOutput(error);
    private _writeUnhandledErrorOutput(error);
    private _writeFailure(message, actual, expected, stack?);
}
